@echo off
rem
rem Batch file my Mick to control instances of reastream on networked pc's to implement a 
rem multi-zone network audio system
rem
rem For further info see http://forums.sagetv.com/forums/showthread.php?t=31524
rem
rem

rem set debug to true (below) when initially setting up new targets
rem this will cause the interface to show so that you can configure the settings

set debug="true"


rem set path to multizone files on all clients (leave quotes out)
set mzpath=C:\program files\sagetv\multizone

cd %mzpath%

rem goto help if no parms provided
IF !%1==! goto help

rem Here's where we handle parameters
set action=%1
set target=%2
set zone=%3
set user=%4
set pass=%5

rem handle username and passowrd params not being present
set uparam=-u
IF !%4==! set uparam=% 
set pparam=-p
IF !%5==! set pparam=% 

rem if debug true then launch reastream interactively on target
if %debug%=="true" set interact=-i

goto %action%
goto end

:listen
echo action is %action%
echo target pc is %target%
echo zone is %zone%
rem echo interact is %interact%
echo.

echo kill all other listening instances on target
pskill \\%target% %uparam% %user% %pparam% %pass% ZoneA.exe
pskill \\%target% %uparam% %user% %pparam% %pass% ZoneB.exe
pskill \\%target% %uparam% %user% %pparam% %pass% ZoneC.exe
pskill \\%target% %uparam% %user% %pparam% %pass% ZoneD.exe

rem skip launch if zone is none
if %zone%==none goto end

rem launch correct listening zone on target
psexec -d %interact% %uparam% %user% %pparam% %pass% \\%target% "%mzpath%\%zone%.exe"

goto end

:send
rem this is where we set a machine to send audio for a zone.  There can be only one per zone!

rem get a list of all pc's currently in the network 

if exist pclist.txt delete pclist.txt
net view > pclist.txt
rem process list of pc's and kill appropriate zone send processes on all pc's on the network
rem this is messy and I should probably use find or something to stop errors popping up.  Maybe later.
rem this should not be used in an environment with too many pc's.
for /F "tokens=* delims=" %%i in (pclist.txt) do pskill %%i %uparam% %user% %pparam% %pass% send%zone%.exe

rem kill all receiving and sending on target.  Presumably we don't want to be creating interesting loops :)
pskill \\%target% %uparam% %user% %pparam% %pass% ZoneA.exe
pskill \\%target% %uparam% %user% %pparam% %pass% ZoneB.exe
pskill \\%target% %uparam% %user% %pparam% %pass% ZoneC.exe
pskill \\%target% %uparam% %user% %pparam% %pass% ZoneD.exe
pskill \\%target% %uparam% %user% %pparam% %pass% sendZoneA.exe
pskill \\%target% %uparam% %user% %pparam% %pass% sendZoneB.exe
pskill \\%target% %uparam% %user% %pparam% %pass% sendZoneC.exe
pskill \\%target% %uparam% %user% %pparam% %pass% sendZoneD.exe

Rem now launch the send zone on the target machine
psexec -d %interact% %uparam% %user% %pparam% %pass% \\%target% "%mzpath%\send%zone%.exe"


goto end

goto end
:help
echo.
echo insert help text here
echo.
echo.
goto end

:end
rem clear env vars so they're not lying about teh place
set user=%
set pass=%
set target=%
set zone=%
set action=%
set mzpath=%
set interact=%
exit